# ##### BEGIN GPL LICENSE BLOCK #####
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# ##### END GPL LICENSE BLOCK #####

# <pep8 compliant>
import bpy
from bpy.types import Panel, Menu
from rna_prop_ui import PropertyPanel


class MuscleButtonsPanel():
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_context = "data"

    @classmethod
    def poll(cls, context):
        engine = context.scene.render.engine
        return context.object.type == 'MUSCLE' # and (engine in cls.COMPAT_ENGINES)


class DATA_PT_context_muscle(MuscleButtonsPanel, Panel):
    bl_label = ""
    bl_options = {'HIDE_HEADER'}
    COMPAT_ENGINES = {'BLENDER_RENDER', 'BLENDER_GAME'}

    def draw(self, context):
        layout = self.layout

        ob = context.object
        muscle = context.muscle
        space = context.space_data

        split = layout.split(percentage=0.65)
        if ob:
            split.template_ID(ob, "data")
            split.separator()
        elif muscle:
            split.template_ID(space, "pin_id")
            split.separator()

class DATA_PT_muscle_test_value(MuscleButtonsPanel, Panel):
    bl_label = "Muscle properties"
    COMPAT_ENGINES = {'BLENDER_RENDER', 'BLENDER_GAME'}

    def draw(self, context):
        layout = self.layout

        split = layout.split()
        col = split.column()
        col.prop(context.muscle, "type")
        if context.muscle.type == "LINEAR":
            col.prop(context.muscle, "omega")
        elif context.muscle.type == "PARALLEL":
            col.prop(context.muscle, "height")
        col.prop(context.muscle, "fs")
        col.prop(context.muscle, "ff")
        if context.muscle.type == "SPHINCTER":
            col.prop(context.muscle, "r")
            col.prop(context.muscle, "h")
        else:
            col.prop(context.muscle, "k")
            col.prop(context.muscle, "wrinkle_n")
            col.prop(context.muscle, "wrinkle_h")

if __name__ == "__main__":  # only for live edit.
    bpy.utils.register_module(__name__)
